/**
 *	
 *  The ActArea class extends important methods to calculate the player-information:
 *	checkHomeZone, checkHomePosition, getHomePositionDirection 
 *	and getHomePositionDistance
 *
 *
 *  @author Henrik Sander
 *  @author Michael Helisch
 *  @author Manuel Link
 *  @author Max Urban
 *  @author Cornelius Siller
 *
 */


public class ActArea
{
	protected double [] field = new double [6];
	protected World world;
	
	
	// constructor
	
	public ActArea ( World world,double [] field)
	{	
		this.field = field;
		this.world = world;
	}
	
	
/**
 * Returns true if player is in HomeZome
 *
 */	
 	
	public boolean checkHomeZone()
	{
		
		double [] position = world.myself.getPosition();
	
		// of the kind x_home,y_home,topline,rightline,bottomline,leftline
		
		
		if (position[0]>field[5] && position[0]<field[3])
		{
			if (position[1]>field[2] && position[1]<field[4])
			{
				return true;
			}
			else
			{
//				System.out.println("Player NOT in Homezone!  -  y-FEHLER");
				return false;			
			}
			
		}
		else
		{
//				System.out.println("Player NOT in Homezone!  -  x-FEHLER");
				return false;
		}	
	
	}
	
	
/**
 *  Returns true if player is in HomePosition with a tolerance of +2/-2 units
 *	
 *
 */	
 	
	public boolean checkHomePosition()
	{
		
		double [] position = world.myself.getPosition();
		
	
//		System.out.println(position[0] + " " + position[1] + " " + field[0]+"  " + field[1] + "  " + field[2] + "  " + field[3]+"  " + field[4] + "  " + field[5]);
		
		
		if (position[0]>field[0] - 2 && position[0]<field[0] + 2)
		{
			if (position[1]>field[1] - 2 && position[1]<field[1] + 2)
			{
				return true;
			}
			else
			{
//				System.out.println("Player NOT on Homeposition!  -  y-FEHLER");
				return false;			
			}
			
		}
		else
		{
//				System.out.println("Player NOT on Homeposition!  -  x-FEHLER");
				return false;
		}	
	
	}



/**
 *
 *	Returns the necessary angle for turning towards the HomePosition-coordinate
 *
 * 	@see checkHomePosition()
 *  
 *
 */
	

   public double getHomePositionDirection()
   {
   	double homeposdir = world.getDirectionFromCoordinates(field);
   	return homeposdir;
   
   }



/**
 *
 *	Returns the distance from the actual position to the HomePosition
 *
 * 	@see checkHomePosition()
 *
 */
	
   public double getHomePositionDistance()
    {
	
    double x,y;	
	double [] position = world.myself.getPosition();
	double distance;
	
    
    x=Math.abs(position[0]-field[0]);
    y=Math.abs(position[1]-field[1]);
    distance=Math.sqrt(x*x+y*y);
	
	return distance;
    
	}	



/**
 *
 *	Returns true if ball is in HomeZome
 *
 *	
 *
 */
	
	public boolean checkBallInHomeZone()
	{
		
		double [] position = world.theBall.getNewPosition();
	
		// of the kind x_home,y_home,topline,rightline,bottomline,leftline
		
		
		if (position[0]>field[5] && position[0]<field[3])
		{
			if (position[1]>field[2] && position[1]<field[4])
			{
				return true;
			}
			else
			{
//				System.out.println("Ball NOT in Homezone!  -  y-FEHLER");
				return false;			
			}
			
		}
		else
		{
//				System.out.println("Ball NOT in Homezone!  -  x-FEHLER");
				return false;
		}	
	
	}
	
	public void switchPos()
	{
		
		this.field[0] = field[0]*-1;// x coordinate HomePosition		
		this.field[1] = field[1]*-1;// y coordinate HomePosition
		double temp;
		temp = field[2];
		this.field[2] = field[4]*-1;// top border
		this.field[4] = temp * -1;// bottom border
		temp = field[3];
		this.field[3] = field[5]*-1;// right border
		this.field[5] = temp * -1;// left border
		 
		 
		 
		 
	}

	
	
}
