//import javax.swing.Timer;
//import java.awt.event.*;

import java.io.*;
import java.util.*;

/**
 *	The Actor class contains the command methods used by the players to send
 *	their actions to the communication channel, which transfers them to the
 *	server. The class also handles the incoming messages from the communication
 *	channel and creates the kind of the event received (Visual, Body, Hear).
 *
 *
 *  @author Henrik Sander
 *  @author Michael Helisch
 *  @author Manuel Link
 *  @author Max Urban
 *  @author Cornelius Siller
 * 
 *
 */
 public class Actor
{

	private CommunicationChannel communicationChannel;
	Player aktualPlayer;


/**
*	Constructor 
*/
	public Actor(CommunicationChannel communicationChannel, Player aktualPlayer, BufferedReader b)
	{
		this.communicationChannel = communicationChannel;
		this.aktualPlayer = aktualPlayer;
		pin = b;
	}

/** 
 *
 *	Initialization for the Player 
 *
 */
 
	public void init(String teamName)
	{
		communicationChannel.send(new String("(init " + teamName + "(version 7.0))"));

	}
/** 
 *
 *	Initialization for the Goalie 
 *
 */
	public void init(String teamName, String g)
    {
		communicationChannel.send(new String("(init " + teamName + "(version 7.0) "+ g +")" ));
    }


/**
 *	Creates the kind of event that was received by the communication
 *	channel and sends it to the specific class for parsing
 *
 */
 
	public Event event()
	{
        Event event = null;
		String t = null;
		String msg = null;
		while (event==null)
		{
		try {	msg = pin.readLine();
			} catch (IOException ioe) {}

		if (msg!=null)
			{ event = aktualPlayer.world.decode(msg); }
		}

        return event;
	}

/**
 * This is the method for running
 *
 */	

	public void dash(double power)
	{
//		if (aktualPlayer.active)
//		{
//			System.out.println("(dash " + power + ")");
//		}
		communicationChannel.send(new String("(dash " + power + ")"));
	}

/**
 * 	Method for catching the ball (only Goalie can use it)
 *
 */

	public void fang(double power)
	{
//		if (aktualPlayer.active)
//		{
//			System.out.println("(catch " + power + ")");
//		}
		communicationChannel.send(new String("(catch " + power + ")"));
	}

/**
 * 	Method for kicking the ball 
 *
 */

	public void kick(double power, double direction)
	{ 
			
		double calculateGD = aktualPlayer.world.theGoal.direction();
		double calculateVD = aktualPlayer.world.myself.getViewDirection();
					
		direction =  calculateGD;
		
//		System.out.println("Kick - Winkel: " + direction);		
		
		
//		if (aktualPlayer.active)
//		{
//			System.out.println("(kick " + power + " " + direction + ")");
//		}
		communicationChannel.send(new String("(kick " + power + " " + direction + ")")); 
	}
  

/**
 *
 *	Method to move the players into their starting positions
 *
 */

	public void move(double x, double y) 
	{
//		if (aktualPlayer.active)
//		{
//			System.out.println("(move " + x + " " + y + ")");
//		}
		communicationChannel.send(new String("(move " + x + " " + y + ")"));
		double[] d = new double[2];
		d[0] = x; d[1] = y; 
    	aktualPlayer.world.myself.setPosition(d, aktualPlayer.world.getTime()); 

	} 
  
/**
 *
 *	Method to turn the Player
 *
 *
 */ 
 
	public void turn(double moment) 
	{ 
		if (aktualPlayer.active)
		{
			aktualPlayer.world.myself.setViewDirection(aktualPlayer.world.myself.getViewDirection() - moment);
			
//			System.out.println("(turn " + moment + ")");
		}
		communicationChannel.send(new String("(turn " + moment + ")")); 
//		aktualPlayer.world.myself.setViewDirection (aktualPlayer.world.myself.getViewDirection() + moment / (1.0 + 5.0*aktualPlayer.world.myself.getSpeed())); 
	} 


// method for logging off the player 
	public void logoff()
	{
		communicationChannel.send(new String("(bye)"));
		
	}


BufferedReader pin;
}

