import java.util.*; 
/** 
 * This class is used as an indicator that a <code>sense_body</code> message was 
 * was received. This type of message is needed to synchronize the actions of the 
 * <code>Player</code> with the action cylces of the server. The <code>see</code> 
 * messages arrive in intervals of 150ms, while the action cycle whithin one 
 * command can be sent is 100ms. Only <code>sense_body</code> messages arrive within 
 * this cycle time. 
 *
 *  @author Henrik Sander
 *  @author Michael Helisch
 *  @author Manuel Link
 *  @author Max Urban
 *  @author Cornelius Siller
 *
 * 
 */ 
 public class BodyEvent extends Event 
{ 

	public ObjectPerception objectPerception;
	protected double speed;
	protected double direction; 
	
	public BodyEvent(String message) 
	{ 

		StringTokenizer tokenizer = new StringTokenizer(message, "()"); 
//		System.out.println(message);
//		tokenizer.nextToken(); 
		time = Integer.parseInt(tokenizer.nextToken().substring(11).trim());
//		System.out.println("time :"+time);
		while (tokenizer.hasMoreTokens()) 
        { 
        	String code=tokenizer.nextToken(); 

        	if (!code.equals(" ")) 
            { 
                StringTokenizer st   = new StringTokenizer(code, " "); 
                String data = st.nextToken(); 

                if (data.equals("speed")) 
                { 
                	this.speed  = Double.valueOf(st.nextToken()).doubleValue(); //Double.parseDouble(st.nextToken()); 
                    this.direction  = Double.valueOf(st.nextToken()).doubleValue(); //Double.parseDouble(st.nextToken()); 
//                  System.out.println("speed: "+speed+"  direction: "+direction); 
                    objectPerception = new ObjectPerception(0, code, speed, direction); 
                } 
            } 
        } 
	} 
  
/** 
 *
 *	Returns <code>true</code> if <code>Event</code> is a <code>BodyEvent</code>
 *
 */
	
	public boolean isBodyEvent() 
	{ 
		return true; 
	}

/** 
 *
 *	Returns actual direction of the <code>Player</code>
 *
 */
 	
	public double getBodyDirection()
	{
		return direction;
	}

/** 
 *
 *	Returns actual direction of the <code>Player</code>
 *
 */

	public double getBodySpeed()
	{
		return speed;
	}

} 
  
