/**
 * The class <code>Event</code> is the superclass of all events to be represented
 * during the game.
 *
 *
 *  @author Henrik Sander
 *  @author Michael Helisch
 *  @author Manuel Link
 *  @author Max Urban
 *  @author Cornelius Siller
 */

public abstract class Event
{
    int time;
	public int getTime()
	{
		return time;
	}
	/**
     * indicates that the event type
     *
     * @return a <code>boolean</code> value indicating that this event is not a
     * <code>BodyEvent</code>
     */
     public boolean isBodyEvent() {return false;}
 
     /**
      * indicates that the event type is VisualEvent
      *
      * @return a <code>boolean</code> value indicating that this event is not a
      * <code>VisualEvent</code>
      */
     public boolean isVisualEvent() {return false;}
 
     /**
      * indicates that the event type is HearEvent
      *
      * @return a <code>boolean</code> value indicating that this event is not a
      * <code>HearEvent</code>
      */
     
     public boolean isHearEvent() {return false;}
     
	
}
