import java.util.*;
import java.io.*;

/**
 * 	This class extends the Player class for the specific Goalie-Player
 *
 *  @author Henrik Sander
 *  @author Michael Helisch
 *  @author Manuel Link
 *  @author Max Urban
 *  @author Cornelius Siller.
 */

public class Goalie extends Player
{

//	boolean defenseStrategy;
	private double[] myArea = new double[6];
    protected boolean caught = false; // used by the catch() method
	
/**
*	Constructor of the class
*/
    public Goalie (String servername, int serverport, String teamName, Team team, boolean defenseStrategy)
    {
		this.defenseStrategy = defenseStrategy;
//		System.out.println(this.defenseStrategy);
        this.teamName = teamName;
        this.team = team;
        
		
		
		if (defenseStrategy)
		{
			// changes two-dimension-field into one-dimension-field
			for (int j = 0; j < 6; j++)
			{
				this.myArea[j] = darea[0][j];
			}
		
		}
		else
		{
			// changes two-dimension-field into one-dimension-field
        	for (int j = 0; j < 6; j++)
        	{
        		this.myArea[j] = area[0][j];
//				System.out.println(myArea[j]);
        	}
		}
        world = new World(this, myArea);
		try 
		{
			PipedWriter pout= new PipedWriter();
			BufferedReader pin = new BufferedReader(new PipedReader(pout));
			CommunicationChannel communication = new CommunicationChannel(servername, serverport, pout);
			communication.start();
			actor   = new Actor(communication, this, pin);
		} 
		catch (IOException ioe) {}
    } // constructor
	
	public boolean isGoalie() 
	{
		return true;
	}

/**
* 	The method setStartPosition() moves the Player to his specific starting 
*	position at the beginning of a half or after a goal
*/

	public void setStartPosition ()
	{
		if (playOnSide.equals("r"))
		{
			actor.move(-world.myActArea.field[0],-world.myActArea.field[1]);
//			System.out.println("Start gesetzt  x: "+ -world.myActArea.field[0] + " y: " + world.myActArea.field[1]);	
		}	
		else
		{
			actor.move(world.myActArea.field[0],world.myActArea.field[1]);
//			System.out.println("Start gesetzt  x: "+ world.myActArea.field[0] + " y: " + world.myActArea.field[1]);	
		}
	}

/**
* 	This method overwrites <code>run()</code> from <code>Thread</code>. It is
* 	executed when <code>start()</code> is called for the <code>Player</code>
* 	Thread
*/
    public void run()
    {
        Event event = null;

        // register player
        actor.init(teamName, "(goalie)");
		

        // and play
        while (true) 
		{
			event = actor.event();
			
			if (initReceived)
			{
			
			
			
            	// update information about the world
            	if (event.isVisualEvent())
            	{
            	}
            	else if (event.isBodyEvent()) // only act upon receipt of a body sense event
				{ 
             
//				    System.out.println("body");
			  		play();
				}  
            } // if
        } // while
    } // run()

/**
*	This method overwrites the runToBall() in the Player class
*	The Goalie has the special ability to catch the ball and therefor needs
*	different instructions when running towards the ball
*/
    public void runToBall()
    {
//     	System.out.println("run to Ball"+ownNumber);
   		if (!(world.verifyBall())) // already found the ball?
   		{
   			// no, look around
   			actor.turn(40);
   		}
   		else
   		{
   			// we found the ball
   			// what is my position?
   			double [] position = world.myself.getTestPosition();
   			// turn to it if necessary but only if new ball info is available
			if (world.theBall.getNewDistance() < 2) 
   			{
     			ballIsNearWhatToDo();		    	
     		}
			else if (Math.abs(world.theBall.direction()) > 1.0 && world.theBall.time()!=time) 
   			{
       		  	if (world.theBall.futurePos)
         		{
         			actor.turn(world.theBall.getNewDirection());
         		
         		}
         		else
         		{
         			actor.turn(world.theBall.direction());
         		}
         		// remember the time of the info the action was based on
 //         	System.out.println("Turning towards ball");
         		time=world.theBall.time();
     		} // if
     		else // if (world.theBall.getNewDistance() > 2) 
     		{								
	   			if (world.myActArea.checkBallInHomeZone() && Math.abs(position[0])>40 && Math.abs(position[1])<15)
   				{
   					actor.dash(100); 
   				}
   				else
   				{
   					homePositionStatus = RETURNTOHOMEPOSITION;
   				}
     		
     	
     		} 
     		// else // ball is near
     		
     	} // else 
     } // runToBall()


/**
*	This method overwrites the <code>ballIsNearWhatToDo()</code> in the 
* 	<code>Player</code> class.
*	When the ball is near to the goalie, he may catch the ball and does so
*/	 

     public void ballIsNearWhatToDo()
     {
		actor.fang(world.theBall.direction());
		try
		{
			sleep(500); // Goalie waits until status is in free_kick status
		}
		catch (InterruptedException ire)
		{
			System.err.println("sleep error goalie");
		}
		actor.move(-50,0);
		try
		{
			sleep(100); // Goalie waits until status is in free_kick status
		}
		catch (InterruptedException ire)
		{
			System.err.println("sleep error goalie");
		}
//		actor.turn(world.theGoal.direction());
//		try
//		{
//			sleep(100); // Goalie waits until status is in free_kick status
//		}
//		catch (InterruptedException ire)
//		{
//			System.err.println("sleep error goalie");
//		}
//		actor.kick(100, 0);
		actor.kick(100, world.theGoal.direction());
		homePositionStatus = INHOMEPOSITION;
							     
	 } // ballIsNearWhatToDo()
} // class
