/**
 * GraphicObject
 *
 * This class is used to save any kind of worldmodel information
 * and visualize them in the worldmodel
 *
 *
 *  @author Henrik Sander
 *  @author Michael Helisch
 *  @author Manuel Link
 *  @author Max Urban
 *  @author Cornelius Siller .
 */
 public class GraphicObject
{
	
	protected String name;

	// Variable type is the indentifier which is coded with follwing patterns 
	// 0 = Myself
	// 1 = Ball
	// 2 = Ball Ghost
	// 3 = Flag
	// 4 = OwnPlayer
	// 5 = GoalDirection
	// 6 = PlayerGhost
	// 7 = ForeignPlayer
	// 8 = UnknownPlayer
		
	protected int type;
	protected double[] position;
	protected double[] goalPosition;
	protected double direction;
	
/* 	standard constructor
 *
 */
	public GraphicObject(String name, int type, double[] position)
	{
		this.position = new double[2];
		this.name = name;
		this.type = type;
		this.position[0] = position[0];
		this.position[1] = position[1];
		this.direction = 0;
	}
/**
 * 	Extended constructor for objects with viewdirection
 *
 */
 	public GraphicObject(String name, int type, double[] position, double direction)
	{
		this.position = new double[2];
		this.name = name;
		this.type = type;
		this.position[0] = position[0];
		this.position[1] = position[1];
		this.direction = direction;
	}
/**
 * 	Super extended constructor ( is used only for the goal object )
 *
 *
 *
 */	
	public GraphicObject(String name, int type, double[] position, double direction, double [] goalPosition)
	{
		this.position = new double[2];
		this.goalPosition = new double[2];
		this.name = name;
		this.type = type;
		this.position[0] = position[0];
		this.position[1] = position[1];
//		System.out.println("Goal x: " + goalPosition[0]);
//		System.out.println("Goal y: " + goalPosition[1]);
		this.goalPosition[0] = goalPosition[0];
		this.goalPosition[1] = goalPosition[1];
		this.direction = direction;
	}	

	
	public double[] getPosition()
	{
		return position;
	}
	
	public double[] getGoalPosition()
	{
		return goalPosition;
	}
	

	
	public int getType()
	{
		return type;
	}
	
	public String getName()
	{
		return name;
	}
	
	public double getDirection()
	{
		return direction;
	}
	
	
}
