import java.util.*; 
/** 
 *	This class parses the "hear" messages the server submits to the player,
 *	checks if they are messages from the referee and if so, sets the new
 *	playstatus, the referee just announced. (Actually this is done in the
 *	updateWorld() method in the world class, but the preparatory work is 
 *	done here in this class)
 *
 *  @author Henrik Sander
 *  @author Michael Helisch
 *  @author Manuel Link
 *  @author Max Urban
 *  @author Cornelius Siller 
 */ 
 
public class HearEvent extends Event 
{ 
  	
	private String playMode;
	private boolean playModeSet = false;

	 
/**
*	Constructor
*/
	public HearEvent(String message) 
	{ 

		StringTokenizer tokenizer = new StringTokenizer(message, "()"); 

//		tokenizer.nextToken(); 

		while (tokenizer.hasMoreTokens()) 
        { 
        	String code=tokenizer.nextToken(); 
//			System.out.println(code);
        	if (!code.equals(" ")) 
            { 
                StringTokenizer st   = new StringTokenizer(code, " ");
				st.nextToken(); // the "hear" Token must be ignored
				int time = Integer.parseInt(st.nextToken());  
				String data = st.nextToken();
//				System.out.println(data); 
               	if (data.equals("referee")) 
               	{
					String refMessage = st.nextToken();
					if (refMessage.equals("before_kick_off"))
					{
						playMode = refMessage;
						playModeSet = true;
					}
					else if (refMessage.equals("play_on"))
					{
						playMode = refMessage;
						playModeSet = true;
					}
					else if (refMessage.startsWith("kick_off"))
					{

						playMode = refMessage;
						playModeSet = true;
					}
					else if (refMessage.startsWith("kick_in"))
					{
						playMode = refMessage;
						playModeSet = true;
					}
					else if (refMessage.startsWith("free_kick"))
					{
						playMode = refMessage;
						playModeSet = true;
					}
					else if (refMessage.startsWith("corner_kick"))
					{
						playMode = refMessage;
						playModeSet = true;
					}
					else if (refMessage.startsWith("goal_kick"))
					{
						playMode = refMessage;
						playModeSet = true;
					}
					else if (refMessage.startsWith("offside"))
					{
						playMode = refMessage;
						playModeSet = true;
					}
					else if (refMessage.startsWith("goal_"))
					{
						playMode = refMessage;
						playModeSet = true;
					}
					else if (refMessage.equals("time_over"))
					{
						playMode = refMessage;
						playModeSet = true;
					}
					
               	} 
 
        	} // if (!code.equals(" "))
		} // while
	} // Constructor
  
/**
 *	Returns true if <code>Event</code> is a <code>HearEvent</code>
 *
 */
	public boolean isHearEvent() 
	{ 
		return true; 
	}

/**
 *	Returns true if <code>playMode</code> is set
 *
 */
 
	public boolean playModeSet()
	{
		return playModeSet;
	}

/**
 *	Returns the actual <code>PlayMode</code>
 *
 */
	
	public String playMode()
	{
		return playMode;
	}



} 
  


