import java.util.*;
import java.io.*;

/**
 * 	This class extends the Player class for the specific Midfield-Player.
 *
 *
 *  @author Henrik Sander
 *  @author Michael Helisch
 *  @author Manuel Link
 *  @author Max Urban
 *  @author Cornelius Siller 
*/

public class Midfield extends Player
{

	private int i;
	double [] myArea = new double [6];
/**
*	This is the constructor of the class
*/
	public Midfield (String servername, int serverport, String teamName, int i, Team team, boolean defenseStrategy)
	{
		this.defenseStrategy = defenseStrategy;
	    this.teamName = teamName;
		this.team = team;
		this.i = i;
		// changes two-dimension-field into one-dimension-field
		if (defenseStrategy)
		{
			// changes two-dimension-field into one-dimension-field
			for (int j = 0; j < 6; j++)
			{
				myArea[j] = darea[i][j];
			}
		
		}
		else
		{
			// changes two-dimension-field into one-dimension-field
			for (int j = 0; j < 6; j++)
			{
				myArea[j] = area[i][j];
			}
		}
		world = new World(this, myArea);
		try 
		{
	
			PipedWriter pout= new PipedWriter();
			BufferedReader pin = new BufferedReader(new PipedReader(pout));
			CommunicationChannel communication = new CommunicationChannel(servername, serverport, pout);
			communication.start();
			actor   = new Actor(communication, this, pin);
		} 
		catch (IOException ioe) {}
	} // constructor
	
/**
* 	Returns true 
*	
*/
	
	public boolean isMidfield() 
	{
		return true;
	}

/**
* 	The method setStartPosition() moves the Player to his specific starting 
*	position at the beginning of a half or after a goal
*/
	public void setStartPosition ()
	{
	if (playOnSide.equals("r"))
	{
		actor.move(-world.myActArea.field[0],-world.myActArea.field[1]);
//		System.out.println("Start gesetzt  x: "+ -world.myActArea.field[0] + " y: " + world.myActArea.field[1]);	
	}	
	else
	{
		actor.move(world.myActArea.field[0],world.myActArea.field[1]);
//		System.out.println("Start gesetzt  x: "+ world.myActArea.field[0] + " y: " + world.myActArea.field[1]);	
	}
	} // setStartPosition()

/**
* 	This method overwrites <code>run()</code> from <code>Thread</code>. It is
* 	executed when <code>start()</code> is called for the <code>Player</code>
* 	Thread
*/
	public void run()
	{
	    Event event = null;

	    // register player
	    actor.init(teamName);

	    // and play
        while (true) 
		{
			event = actor.event();
			
			if (initReceived)
			{
			
			
			
            	// update information about the world
            	if (event.isVisualEvent())
            	{
            	}
            	else if (event.isBodyEvent()) // only act upon receipt of a body sense event
				{ 
             
//				    System.out.println("body");
			  		play();
				}  
            } // if
        } // while
	} // run()
} // class
