
/**
 *	The class MovingObjectPerception saves and follows moving objects during the game
 *  By using five old positions it calculates an appropirate future position
 *
 *
 *  @author Henrik Sander
 *  @author Michael Helisch
 *  @author Manuel Link
 *  @author Max Urban
 *  @author Cornelius Siller 
 */

public class MovingObjectPerception extends ObjectPerception 
{ 
  
  	// memory for old positions
	private   double[] Coordinates_0 = new double[2];
	protected double[] Coordinates_1 = new double[2];
	protected double[] Coordinates_2 = new double[2];
	protected double[] Coordinates_3 = new double[2];
	protected double[] Coordinates_4 = new double[2];
	protected double[] Coordinates_5 = new double[2];
	protected int time_0 = -1;
	protected int time_1 = -1;
	protected int time_2 = -1;
	protected int time_3 = -1;
	protected int time_4 = -1;
	protected int time_5 = -1;
	
	// calculated future position
	private double[] newCoordinates = new double[2];
	private int newTime = -1;
	private double newDirection = 0; 
	private double newDistance = 0;
	 
	private double Speed = 0; 
	private double ViewDirection = 0;
	private double BodyDirection = 0; 

	public String player_name; 
	public String team_name; 

	// this varible indicates if an future position is aviable
	boolean futurePos = false;
	
	
	private double[] testCoordinates = new double[2];
	
/**
 *	Constructor
 */
 	
	public MovingObjectPerception() 
	{ 
		super(); 
	} 

	public MovingObjectPerception(ObjectPerception oe) 
	{ 
		this.time_0=oe.time; 
		this.name=new String(oe.name()); 
		this.distance=oe.distance; 
		this.direction=oe.direction; 
	} 
  
  
/**
 *
 *	Updates Memory
 */
 
	public void setPosition(double [] c, int t) 
	{ 	
		// time update
		time_5 = time_4;
		time_4 = time_3;
		time_3 = time_2;
		time_2 = time_1;
		time_1 = time_0;
		time_0 = t;
		// Position update
		Coordinates_5[0] = Coordinates_4[0];
		Coordinates_5[1] = Coordinates_4[1];
		Coordinates_4[0] = Coordinates_3[0];
		Coordinates_4[1] = Coordinates_3[1];
		Coordinates_3[0] = Coordinates_2[0];
		Coordinates_3[1] = Coordinates_2[1];
		Coordinates_2[0] = Coordinates_1[0];
		Coordinates_2[1] = Coordinates_1[1];
		Coordinates_1[0] = Coordinates_0[0];
		Coordinates_1[1] = Coordinates_0[1];
		Coordinates_0[0] = c[0];
		Coordinates_0[1] = c[1];
		testCoordinates[0] = c[0]; 
		testCoordinates[1] = c[1]; 
	} 

	public int time() 
	{ 
		return time_0; 
	} 
	
	
	public void setTime( int t)
	{
		time_0 = t;
	}
	
	public double[] getPosition() 
	{ 
		double [] x = {0,0};
		if (Coordinates_0 != null)
		{
			x = Coordinates_0;
		}
		return x; 
	} 
	
  	
	public double[] getTestPosition()
	{
		return testCoordinates;
	}
	
	public void setTestPosition(double [] jk)
	{
		testCoordinates[0] = jk[0];
		testCoordinates[1] = jk[1];
	}
	
	public double[] getNewPosition()
	{
		return newCoordinates;
	}
	
	public int getNewTime()
	{
		return newTime;
	}
	
	public void setNewDirection(double s) 
	{ 
		newDirection = s; 
	} 
  

	public double getNewDirection() 
	{ 
		return newDirection; 
	} 
	
	public void setNewDistance(double s) 
	{ 
		newDistance = s; 
	} 
  

	public double getNewDistance() 
	{ 
		return newDistance; 
	} 
	
	public void setSpeed(double s) 
	{ 
		Speed = s; 
	} 
  

	public double getSpeed() 
	{ 
		return Speed; 
	} 
  

	public void setViewDirection(double v) 
	{ 
		ViewDirection = v; 
	} 
  

	public double getViewDirection() 
	{ 
		return ViewDirection; 
	} 
	
	public void setBodyDirection(double b) 
	{ 
		BodyDirection = b; 
	} 
  

	public double getBodyDirection() 
	{ 
		return BodyDirection; 
	} 


// this function was added by Cornelius (has been replaced by futureIt())???
//	public void move(int time) 
//	{ 
//		int time_difference = time - last_change_time; 
//		Coordinates[0] += Speed * 25 * java.lang.Math.cos(ViewDirection*java.lang.Math.PI*2.0/360)*(double)(time_difference)/1000; 
//		Coordinates[1] += Speed * 25 * java.lang.Math.sin(ViewDirection*java.lang.Math.PI*2.0/360)*(double)(time_difference)/1000; 
//		last_change_time = time; 
//	} 
	
	
	// this main function calculates the new future position based on 3 old positions
	// the future position has got the timestamp of actualtime + addTime
	public boolean futureIt(int addTime)
	{	
		boolean back = false;
		int diffTime_0 = time_0 - time_1;
		if ( time_1 >= 0 && diffTime_0 >0)
		{
//			int diffTime = time - oldTime; 
			double diffX = Coordinates_0[0] - Coordinates_1[0];
			double diffY = Coordinates_0[1] - Coordinates_1[1];
			newCoordinates[0] = Coordinates_0[0] + 0.5 * diffX *( addTime/diffTime_0 );
			newCoordinates[1] = Coordinates_0[1] + 0.5 * diffY *( addTime/diffTime_0 );
			newTime = time_0 + addTime;
			int diffTime_1 = time_1 - time_2;
			if (time_2 >= 0 && diffTime_1 >0)
			{
				 
				diffX = Coordinates_1[0] - Coordinates_2[0];
				diffY = Coordinates_1[1] - Coordinates_2[1];
				newCoordinates[0] = newCoordinates[0] + 0.3 * diffX *( addTime/diffTime_1);
				newCoordinates[1] = newCoordinates[1] + 0.3 * diffY *( addTime/diffTime_1);
				int diffTime_2 = time_2 - time_3;
				if (time_3 >= 0 && diffTime_2 >0)
				{
				 
					diffX = Coordinates_2[0] - Coordinates_3[0];
					diffY = Coordinates_2[1] - Coordinates_3[1];
					newCoordinates[0] = newCoordinates[0] + 0.2 * diffX *( addTime/diffTime_2);
					newCoordinates[1] = newCoordinates[1] + 0.2 * diffY *( addTime/diffTime_2);
				}
			}
			back = true;
		}
		return back;
	}
	// this advaced main function calculates the new future position based on up to 5 old positions
	// posCount is the variable which indicates the number of used positions
	// the future position has got the timestamp of actualtime + addTime
	//
	// ATTENTION!!
	// the function is not yet implemented correctly! Use only with posCount = 5!
	// Use on own RISK!
	//
	public boolean futureIt(int addTime, int posCount)
	{	
		boolean back = false;
		int diffTime_0 = time_0 - time_1;
		if ( time_1 >= 0 && diffTime_0 >0)
		{	
		

			double diffX = Coordinates_0[0] - Coordinates_1[0];
			double diffY = Coordinates_0[1] - Coordinates_1[1];
			newCoordinates[0] = Coordinates_0[0] + 0.4 * diffX *( addTime/diffTime_0 );
			newCoordinates[1] = Coordinates_0[1] + 0.4 * diffY *( addTime/diffTime_0 );
			newTime = time_0 + addTime;
			int diffTime_1 = time_1 - time_2;
			if (posCount >= 2 && time_2 >= 0 && diffTime_1 >0)
			{
				 
				diffX = Coordinates_1[0] - Coordinates_2[0];
				diffY = Coordinates_1[1] - Coordinates_2[1];
				newCoordinates[0] = newCoordinates[0] + 0.3 * diffX *( addTime/diffTime_1);
				newCoordinates[1] = newCoordinates[1] + 0.3 * diffY *( addTime/diffTime_1);
				int diffTime_2 = time_2 - time_3;
				if (posCount >= 3 && time_3 >= 0 && diffTime_2 >0)
				{
				 
					diffX = Coordinates_2[0] - Coordinates_3[0];
					diffY = Coordinates_2[1] - Coordinates_3[1];
					newCoordinates[0] = newCoordinates[0] + 0.15 * diffX *( addTime/diffTime_2);
					newCoordinates[1] = newCoordinates[1] + 0.15 * diffY *( addTime/diffTime_2);
					int diffTime_3 = time_3 - time_4;
					if (posCount >= 4 && time_4 >= 0 && diffTime_3 >0)
					{
				 
						diffX = Coordinates_3[0] - Coordinates_4[0];
						diffY = Coordinates_3[1] - Coordinates_4[1];
						newCoordinates[0] = newCoordinates[0] + 0.1 * diffX *( addTime/diffTime_3);
						newCoordinates[1] = newCoordinates[1] + 0.1 * diffY *( addTime/diffTime_3);
						int diffTime_4 = time_4 - time_5;
						if (posCount >= 5 && time_5 >= 0 && diffTime_4 >0)
						{
				 
							diffX = Coordinates_4[0] - Coordinates_5[0];
							diffY = Coordinates_4[1] - Coordinates_5[1];
							newCoordinates[0] = newCoordinates[0] + 0.05 * diffX *( addTime/diffTime_4);
							newCoordinates[1] = newCoordinates[1] + 0.05 * diffY *( addTime/diffTime_4);
						}
					}
				}
			}
			back = true;
		}
		return back;
	}
	
} 
  
