import java.util.*;

/**
 *	The class ObjectPerception calculates the distance and direction to 
 *	known objects
 *
 *
 *  @author Henrik Sander
 *  @author Michael Helisch
 *  @author Manuel Link
 *  @author Max Urban
 *  @author Cornelius Siller
 */ 

public class ObjectPerception 
{ 

	protected int     time; 
	protected String  name; 
	protected double  distance; 
	protected double  direction; 
	protected double[] Coordinates; 

	public ObjectPerception()
	{
	}

/**
 *
 * 	constructor calculates on call the appropirate position of known objects
 *
 */

	public ObjectPerception(int time, String name, double distance, double direction) 
	{ 
		this.time=time; 
		this.name=name; 
		this.distance=distance; 
		this.direction=direction; 

		if (name.startsWith("f")) 
        { 
        	Coordinates = new double[2]; 
        	StringTokenizer tokenizer = new StringTokenizer(name, " "); 
        	int count = tokenizer.countTokens(); 
        	tokenizer.nextToken(); 
        	if (count==4) 
        	{ 
                String next = tokenizer.nextToken(); 
                if (next.equals("t")) { Coordinates[1] = -39.0; } 
                else if (next.equals("r")) { Coordinates[0] = 57.5; } 
                else if (next.equals("b")) { Coordinates[1] = 39.0; } 
                else if (next.equals("l")) { Coordinates[0] = -57.5; } 
                else if (next.equals("p")) 
                { 
                	next = tokenizer.nextToken(); 
                    if (next.equals("l")) { Coordinates[0] = -36.0; } 
                    else if (next.equals("r")) { Coordinates[0] = 36.0; } 
                    next = tokenizer.nextToken(); 
                    if (next.equals("c")) { Coordinates[1] = 0.0; } 
                    else if (next.equals("t")) { Coordinates[1] = -20.0; } 
                    else if (next.equals("b")) { Coordinates[1] = 20.0; } 
                    return; 
                } 
                else if (next.equals("g")) 
                { 
                	next = tokenizer.nextToken(); 
                    if (next.equals("l")) { Coordinates[0] = -52.5; } 
                    else if (next.equals("r")) { Coordinates[0] = 52.5; } 
                    next = tokenizer.nextToken(); 
                    if (next.equals("t")) { Coordinates[1] = -7.5; } 
                    else if (next.equals("b")) { Coordinates[1] = 7.5; } 
                    return; 
                } 
                next = tokenizer.nextToken(); 
                int dist = Integer.parseInt(tokenizer.nextToken()); 
                if (next.equals("t")) { Coordinates[1] = -dist; } 
                else if (next.equals("b")) { Coordinates[1] = dist; } 
                else if (next.equals("r")) { Coordinates[0] = dist; } 
                else if (next.equals("l")) { Coordinates[0] = -dist; } 
            } 
        	else if (count==3) 
            { 
                String next = tokenizer.nextToken(); 
                if (next.equals("l")) { Coordinates[0] = -52.5; } 
                else if (next.equals("c")) { Coordinates[0] = 0.0; } 
                else if (next.equals("r")) { Coordinates[0] = 52.5; } 
                next = tokenizer.nextToken(); 

                boolean isnum = true;
				
				try 
                { 
				int dist = Integer.parseInt(next); 
                } catch (NumberFormatException noe) 
                { 
				isnum = false; 
                }

                if (isnum == false) 
					{ 
					if (next.equals("t")) { Coordinates[1] = -34.0; } 
                	else if (next.equals("b")) { Coordinates[1] = 34.0; } 
					}
				else
					{
					if (Coordinates[0] == -52.5) 
						{ Coordinates[0] = -57.5; }
					else 
						{ Coordinates[0] = 57.5; }
					Coordinates[1] = 0.0;
					}
            } 
        	else if (count==2) 
            { 
                String next = tokenizer.nextToken(); 
                if (next.equals("c")) { Coordinates[0] = 0.0; Coordinates[1] = 0.0;} 
            } 
		
        } 
		else if (name.startsWith("g"))
		{
		Coordinates = new double[2]; 
		StringTokenizer tokenizer = new StringTokenizer(name, " "); 
	    String next = tokenizer.nextToken(); 
	    if (next.equals("l")) { Coordinates[0] = -52.8; } 
		else if (next.equals("r")) { Coordinates[0] = 52.8; }
		Coordinates[1] = 0.0;
		}
	
	} 
/**
 *	Prints name and position of known objects
 *
 */	

	public void printObject()
	{
		System.out.println("| Name          : " + name());
		System.out.println("| Time          : " + time());
		System.out.println("| X-Postiton    : " + getCoordinates()[0] );
		System.out.println("| Y-Postiton    : " + getCoordinates()[1] );
	}

/**
 *	Returns <code>time</code>
 *
 */
	public int time() 
	{ 
		return time; 
	} 
	
/**
 *	Sets time
 *
 */
	public void setTime( int t)
	{
		time = t;
	}

/**
 *	Returns the name of an Object
 *
 */
	public String name() 
	{ 
		return name; 
	} 


/**
 *	Returns the distance to an object
 *
 */
	public double distance() 
	{ 
		return distance; 
	}

	public void setDistance(double d)
	{
		distance = d;
	}

/**
 *	Returns direction to an object
 *
 */

	public double direction() 
	{ 
		return direction; 
	} 
	public void setDirection(double de)
	{
		direction = de;
	}

/**
 *	Returns coordinates of an object
 *
 */

	public double[] getCoordinates() 
	{ 
		double [] x = {0,0};
		if (Coordinates != null)
		{
			x = Coordinates;
		}
		return x; 
	} 
	public void setPosition (double[] sp)
	{
		Coordinates = sp;
	}

	public String toString() 
	{ 
		return name; 
	} 



} 
  
