import java.util.*;

 /**
 *	This class contains the main() method of our program. It is used to start
 * 	the different player Threads (according to their types, such as Goalie,
 *	Defense, Midfield, Offense) and transfers to them the necessary information  
 *	about the used servername, serverport to ensure that the communication with
 *	the server is functionable
 *
 *  @author Henrik Sander
 *  @author Michael Helisch
 *  @author Manuel Link
 *  @author Max Urban
 *  @author Cornelius Siller 
 */
 public class Team
{

	public boolean newGraphic; // not in use
	public Vector GraphicList;
	public WorldModel worldModel;
	public Player pa[];
	boolean defensiveStrategy;
	
	
	
/**
*	Constructor
*/	
 	public Team()
		
 	{
		newGraphic = true;
 	}

/**
*	The main() method
*/
 	public static void main (String[] args) {
        

		
		Team team = new Team();
		if (args.length < 4 || args.length > 5) 
		{
            System.out.println("Usage : java Team SERVERNAME PORT TEAMNAME STRATEGY [\"Graphic\"]");
			System.out.println("where STRATEGY has to be \"d\" for defensive playing or any string for offensive playing");
            System.exit(1);
        }
		else if (args.length == 5)
		{
			WorldModel worldModel = new WorldModel(team);
			worldModel.pack();
			worldModel.setSize(1024,740);	
			worldModel.show();
			worldModel.setVisible(true);
			team.worldModel = worldModel;
		}
		
		Player pa[] = new Player[11];
		
		if (args[3].equals("d"))
		{
			team.defensiveStrategy = true;
			System.out.println("DEFENSE");
		}
		else
		{
			team.defensiveStrategy = false;
		}
		/** initialisation for the goalie */
		pa[0] = new Goalie( args[0], Integer.parseInt(args[1]), args[2],team, team.defensiveStrategy);
	    pa[0].start();
		try
    	{
    		Thread.sleep(100); // sleep, to make sure players are initialized in right order
    	}
    	catch (InterruptedException ire)
    	{
    		System.err.println("sleep error");
    	}
			
		/** initialisation of defense, midfield and offense */
		
		for(int i = 1; i < 11; i++)
        {
			if (i <= 3) // 3 Defense-Player
			{
				pa[i] = new Defense( args[0], Integer.parseInt(args[1]), args[2],i,team, team.defensiveStrategy);
			}
			
			if (i > 3 && i <= 7) // 4 Midfield-Player
			{
				pa[i] = new Midfield( args[0], Integer.parseInt(args[1]), args[2],i,team, team.defensiveStrategy);
			}
			
			if (i > 7) // 3 Offense-Player
			{
				pa[i] = new Offense( args[0], Integer.parseInt(args[1]), args[2],i,team, team.defensiveStrategy);
			}
        
        	pa[i].start();
			try
    		{
    			Thread.sleep(100);
    		}
    		catch (InterruptedException ire)
    		{
    			System.err.println("sleep error");
    		}
        }
		team.pa = pa;
    }	
}
