import java.util.*; 

/**
 *
 *
 *
 *  @author Henrik Sander
 *  @author Michael Helisch
 *  @author Manuel Link
 *  @author Max Urban
 *  @author Cornelius Siller
 */ 



public class VisualEvent extends Event 
{ 
  		
	protected Vector objectPerceptionList;
	Player aktualPlayer;
	

	static double [] pos = new double[2];
	
	public Enumeration elements() 
	{ 
		return objectPerceptionList.elements(); 
	} 
  

	public void add(ObjectPerception objectPerception) 
	{ 
		objectPerceptionList.addElement(objectPerception); 
	} 
  

	public boolean isVisualEvent() 
	{ 
		return true; 
	} 
  
/** constructor parses all message-objects to vector objectPerceptionList*/

	public VisualEvent(String message, Player aktualPlayer) 
	{ 
		objectPerceptionList = new Vector();
		this.aktualPlayer = aktualPlayer;
		StringTokenizer tokenizer = new StringTokenizer(message, "()"); 

		time = Integer.parseInt(tokenizer.nextToken().substring(4).trim()); 

		while (tokenizer.hasMoreTokens()) 
        { 
        	String code=tokenizer.nextToken(); 

       		if (!code.equals(" ")) 
            { 
				String data = tokenizer.nextToken(); 

             	tokenizer.nextToken();
               	switch (code.charAt(0)) 
                { 
                	case 'b': 
                    case 'g': 
                    case 'f': 
                    case 'l': 
                    case 'p': 
                    StringTokenizer st   = new StringTokenizer(data, " "); 
                    double distance  = Double.valueOf(st.nextToken()).doubleValue(); //Double.parseDouble(st.nextToken()); 
                    double direction = Double.valueOf(st.nextToken()).doubleValue(); //Double.parseDouble(st.nextToken()); 
                    ObjectPerception objectPerception = new ObjectPerception(time, code, distance, direction); 
                    this.add(objectPerception); 
                    break; 
                } 
            }	 
        }	 
	} 
  

/** this function calculates the view dircetion in relation to base lines*/
	
	public ObjectPerception getGoal()
	{
		ObjectPerception go = null; 
		int i=0; 

		while (i<objectPerceptionList.size()) 
        { 
        	go = (ObjectPerception)(objectPerceptionList.elementAt(i)); 

        	if (go.name().startsWith("g "+aktualPlayer.oppGoal)) 
            { 
                break; 
            } 
        	i++; 
        } 
		
		return go;
	}
		
	public double getMyViewDirection() 
	{ 
		int i=0; 
		double view_direction = 0; 

		Vector voe = new Vector(); 

		ObjectPerception oe = null; 
		ObjectPerception te; 
		while (i<objectPerceptionList.size()) 
        { 
       		te = (ObjectPerception)(objectPerceptionList.elementAt(i)); 

        	if (te.name().startsWith("l")) 
            { 
                voe.add(te); 
            } 
        	i++; 
        } 

		if (voe.size() == 0) 
        { 
       		return  Double.POSITIVE_INFINITY; 
        } 
		else if (voe.size() == 2) 
        { 
        	if (((ObjectPerception)voe.elementAt(0)).distance()>((ObjectPerception)voe.elementAt(1)).distance()) 
                { oe = (ObjectPerception)voe.elementAt(0); } 
        	else { oe = (ObjectPerception)voe.elementAt(1); } 
        } 
		else
		{ 
       		oe = (ObjectPerception)voe.elementAt(0); 
        } 

		if (oe.name().startsWith("l t")) 
        { 
        	if (oe.direction()>0) 
                 { view_direction = oe.direction(); } 
        	else { view_direction = 180 + oe.direction(); } 
        } 
		else if (oe.name().startsWith("l r")) 
        { 
        	if (oe.direction()>0) 
                 { view_direction = -90 + oe.direction(); } 
        	else { view_direction = 90 + oe.direction(); } 
        } 
		else if (oe.name().startsWith("l b")) 
        { 
        	if (oe.direction()>0) 
                 { view_direction = -180 + oe.direction(); } 
        	else { view_direction = oe.direction(); } 
        } 
		else if (oe.name().startsWith("l l")) 
        { 
       		if (oe.direction()>0) 
                 { view_direction = 90 + oe.direction(); } 
        	else { view_direction = -90 + oe.direction(); } 
        } 
		return ( view_direction); 
	} 

	public double[] getMyPosition() 
	{ 

		double view_direction = getMyViewDirection(); 
		if (view_direction > 360) 
        	{ return null; } 

		ObjectPerception se = getShortestDistance(); 
		if (se==null) 
        	{ return null; } 
  

		double [] temp = new double[2]; 

		temp[0] = se.getCoordinates()[0] - java.lang.Math.cos(( view_direction - se.direction())*2*java.lang.Math.PI/360.0) * se.distance(); 
//		if (aktualPlayer.isGoalie())
//		{
//		if( temp[0] > 55)
//		{	
//			
//			System.out.println("name :"+se.name);
//			System.out.println("distance :"+se.distance);
//			System.out.println("nahste Fahne_x :"+se.getCoordinates()[0]);
//			System.exit(0);
//			
//		}
//		}
		temp[1] = - se.getCoordinates()[1] - java.lang.Math.sin((view_direction - se.direction())*2*java.lang.Math.PI/360.0) * se.distance(); 
		temp[1] = temp[1] * -1;

		pos = temp;
		return temp; 
		


	} 

	public Vector getPlayerList(int time) 
	{ 
		Vector p = new Vector(); 
		int i=0; 
		ObjectPerception te = null; 
		MovingObjectPerception oe = null; 

		while (i<objectPerceptionList.size()) 
        { 
       		te = (ObjectPerception)(objectPerceptionList.elementAt(i)); 

        	if (te.name().startsWith("p")) 
            { 
            	p.add(new MovingObjectPerception(te)); 
            } 
        	i++; 
        } 

		if (p.size() == 0) 
        { 
       		return p; 
        } 

		double [] mp = getMyPosition(); 
		if (mp == null || Double.isNaN(mp[0])) 
        { 
        	return new Vector(); 
        } 

		double direction; 
  

		double [][] temp = new double[2][p.size()]; 

		for (i=0; i<p.size(); i++) 
        { 
        	oe = (MovingObjectPerception)p.elementAt(i); 
        	direction = - oe.direction() + getMyViewDirection(); 

        	double [] ct = new double[2]; 
        	ct[0] = mp[0] + java.lang.Math.cos(direction*2*java.lang.Math.PI/360.0) * oe.distance(); 
        	ct[1] = mp[1] - java.lang.Math.sin(direction*2*java.lang.Math.PI/360.0) * oe.distance(); 

        	oe.setPosition(ct, time); 

        } 
		return p; 
	} 
  
  
   	public ObjectPerception getBall()
   	{
		ObjectPerception ob = null; 
		int i=0; 

		while (i<objectPerceptionList.size()) 
        { 
        	ob = (ObjectPerception)(objectPerceptionList.elementAt(i)); 

        	if (ob.name().startsWith("b")) 
            { 
                break; 
            } 
        	i++; 
        } 
		
		return ob;
   	}

	public double [] getBallPosition() 
	{ 

		ObjectPerception oe = null; 
		int i=0; 

		while (i<objectPerceptionList.size()) 
        { 
        	oe = (ObjectPerception)(objectPerceptionList.elementAt(i)); 

        	if (oe.name().startsWith("b")) 
            { 
                break; 
            } 
        	i++; 
        } 

		if (i==objectPerceptionList.size()) 
        { 
        	return null; 
        } 

		double [] mp = getMyPosition(); 
		if (mp == null || Double.isNaN(mp[0])) 
        { 
       		return null; 
        } 

		double direction = - oe.direction() + getMyViewDirection(); 
  

		double [] temp = new double[2]; 

		temp[0] = mp[0] + java.lang.Math.cos(direction*2*java.lang.Math.PI/360.0) * oe.distance(); 
		temp[1] = mp[1] - java.lang.Math.sin(direction*2*java.lang.Math.PI/360.0) * oe.distance(); 

		return temp; 
	} 
  
	public double [] getPlayerPosition(ObjectPerception player) 
	{ 

		double [] mp = getMyPosition(); 
		if (mp == null || Double.isNaN(mp[0])) 
        { 
       		return null; 
        } 

		double direction = - player.direction() + getMyViewDirection(); 
  

		double [] temp = new double[2]; 

		temp[0] = mp[0] + java.lang.Math.cos(direction*2*java.lang.Math.PI/360.0) * player.distance(); 
		temp[1] = mp[1] - java.lang.Math.sin(direction*2*java.lang.Math.PI/360.0) * player.distance(); 

		return temp; 
	} 

	public ObjectPerception getShortestDistance() 
	{ 

		ObjectPerception temp = null; 
		int i=0; 
		while (temp==null && i<objectPerceptionList.size()) 
        { 
        	if(((ObjectPerception)objectPerceptionList.elementAt(i)).name().startsWith("f")) 
            { 
            	temp = (ObjectPerception)objectPerceptionList.elementAt(i); 
            } 
        	i++; 
        } 
		if (temp==null) 
		{	
			System.out.println("Sehe keine Fahne!?!");
			return null;
		} 
  

		for (int j=0; j<objectPerceptionList.size(); j++) 
        { 
        	if(((ObjectPerception)objectPerceptionList.elementAt(j)).name().startsWith("f") 
            && (temp.distance()>((ObjectPerception)objectPerceptionList.elementAt(j)).distance())) 
            { 
                temp = (ObjectPerception)(objectPerceptionList.elementAt(j)); 
            } 
        } 
		return temp; 
	} 
	
	 


} 
  
  
  
  
