import javax.swing.Timer; 
import java.awt.event.*; 
import java.util.*; 

/**
 *
 *
 *
 *
 *  @author Henrik Sander
 *  @author Michael Helisch
 *  @author Manuel Link
 *  @author Max Urban
 *  @author Cornelius Siller
 */ 

public class World // implements ActionListener
{
	/** Saves all visual elements */
	protected MovingObjectPerception myself = new MovingObjectPerception();
	protected MovingObjectPerception theBall = new MovingObjectPerception();
	protected ObjectPerception theGoal = new ObjectPerception();
	private Player aktualPlayer;
	protected Event event;
//	private boolean act;
	Vector other_players = new Vector(); 
	int time = 0; 
	double goal_r[] =	{52.5, 0};
	double goal_l[] = {-52.5, 0};
	double aimGoal[];
	protected ActArea myActArea;
//	boolean futurePos = false;
	
	
// Constructor 	
	public World(Player aktualPlayer, double [] myarea)
	{
		myActArea = new ActArea(this,myarea);
		this.aktualPlayer = aktualPlayer;	
	}
	
	
//  Not in use	
	public void init()
	{
		
	}	
// This function decodes all Events coming in	
	public Event decode( String msg )
	{
		
        Event event = null;
		if (msg.startsWith("(see")) 
        { 
//			if (aktualPlayer.isGoalie())
//			{	
//				System.out.println("see "+ time);
//			}
           	event = new VisualEvent(msg,aktualPlayer); 
        } 
        if (msg.startsWith("(sense_body")) 
        { 
//			if (aktualPlayer.isGoalie())
//			{	
//				System.out.println("body "+time);
//			}
           	event = new BodyEvent(msg); 
        }
		if (msg.startsWith("(hear"))            
		{
			event = new HearEvent(msg);
//			if (aktualPlayer.isGoalie())
//				System.out.println("hear");
		}

		if (msg.startsWith("(init"))
		{
//			System.out.println("init received");
			aktualPlayer.setPlaySide(msg.substring(6,8).trim());
			aktualPlayer.setNumber(Integer.parseInt(msg.substring(8,10).trim()));
			int l = msg.length();
			aktualPlayer.setPlayMode(0);
			if (aktualPlayer.oppGoal.equals("r"))
			{
				aimGoal = goal_r;
				theGoal.setPosition( aimGoal );
			}
			else
			{
				myActArea.switchPos();
				aimGoal = goal_l;
				theGoal.setPosition( aimGoal );
			}
			aktualPlayer.initReceived = true;
										
		}  
  
		if (event == null) 
		{
//			System.out.println("received nothing");
		}
      
		this.event = event;
//		act = true;
        updateWorld(event); 
		return event;         	
	} // decode()
	
	public Event getEvent()
	{
		return event;
	}
//	public boolean getAct()
//	{
//		return act;
//	}
//	public void setAct(boolean act)
//	{
//		this.act = act;
//	}
	public int getTime()
	{
		return time;
	}


// This function checks the quality of the ballinformation
	public boolean verifyBall()
	{
		if (theBall != null)
		{
			int timeDifference = this.time - theBall.time();
			if ( (timeDifference) <= 3 )
			{
				return true;
			}
			else
			{
				return false;
			}
		}
		else
		{
			return false;
		}		
		
	} // verifyBall()

//  Main function for updating the global world varibles 
//  	
	public void updateWorld(Event e) 
	{ 
		
//		System.out.println("timer :"+time);
		if (e != null)
		{
		
			if (e.isVisualEvent()) 
   			{ 
				time = e.getTime();
				
				// players update
        		if (((VisualEvent)e).getMyPosition()!=null) 
            	{ 
                	myself.setPosition(((VisualEvent)e).getMyPosition(), time); 
	                myself.setViewDirection(((VisualEvent)e).getMyViewDirection());
					myself.futurePos = myself.futureIt(1); 
	            } 
    	    	else 
				{ 
				
				} 
				// ball update
    	    	if (((VisualEvent)e).getBallPosition()!=null) 
        	    { 
					ObjectPerception b = ((VisualEvent)e).getBall();
//					((ObjectPerception)theBall).setTime(b.time());
					((ObjectPerception)theBall).setDistance(b.distance());
					((ObjectPerception)theBall).setDirection(b.direction());
					theBall.setPosition(((VisualEvent)e).getBallPosition(), b.time());
					if (theBall.distance() < 4)
					{
						theBall.futurePos = theBall.futureIt(4);
					}
					else
					{
						theBall.futurePos = theBall.futureIt(5,6);
					}
					theBall.setNewDirection(getDirectionFromCoordinates(theBall.getNewPosition()));
					theBall.setNewDistance(getDistanceFromCoordinates(theBall.getNewPosition()));
				}
				 
//				if (((VisualEvent)e).getGoal()!=null) 
//    	        { 
//					ObjectPerception g = ((VisualEvent)e).getGoal();
//					((ObjectPerception)theGoal).setTime(g.time());
//					((ObjectPerception)theGoal).setDistance(g.distance());
//					((ObjectPerception)theGoal).setDirection(g.direction());
//				} 

					theGoal.setDirection(getDirectionFromCoordinates(theGoal.getCoordinates()));


	
    	    	Vector tp = ((VisualEvent)e).getPlayerList(time); 
        		other_players = tp;

// Updatefunction call for the graphicmodel			
				if (aktualPlayer.active)
				{
					aktualPlayer.updateGraphic(getGraphicList((VisualEvent)event));
				}	
	
	
// Print command for a specified playergroup
//				printPlayer(aktualPlayer.ownNumber == 1); 				 

	        } 

			else if (e.isBodyEvent()) 
    	    { 
				time = e.getTime();
				
			
				// BodyDirection and viewDirection are NOT equal
				// HELP!!!!
				
				myself.setBodyDirection(((BodyEvent)e).getBodyDirection());
				myself.futurePos = myself.futureIt(1);
				if ( myself.time() < time )
				{	
					myself.setTestPosition(myself.getNewPosition());
				}
				theGoal.setDirection(getDirectionFromCoordinates(aimGoal));
//				printPlayer(aktualPlayer.ownNumber == 1); 				 
//				myself.setViewDirection(((BodyEvent)e).direction);
//				myself.setSpeed(((BodyEvent)e).speed);
	        }
			else if (e.isHearEvent())
			{
				if (((HearEvent)e).playModeSet())
				{
//					System.out.println(" gdjsjfl");
					if (((HearEvent)e).playMode().equals("before_kick_off"))
					{
						aktualPlayer.setPlayMode(0);
						
					}
					else if (((HearEvent)e).playMode().equals("play_on"))
					{
						aktualPlayer.setPlayMode(1);
						
					}
					else if (((HearEvent)e).playMode().equals("time_over"))
					{
						aktualPlayer.actor.logoff();
					}
					else
					{				  
						boolean forOurSide = ((HearEvent)e).playMode().substring(((HearEvent)e).playMode().length() - 1).equals(aktualPlayer.getPlaySide());
						if (((HearEvent)e).playMode().startsWith("kick_off"))
						{
							if (forOurSide)
							{
								aktualPlayer.setPlayMode(1);
							}
							else
							{
								aktualPlayer.setPlayMode(2);
							}
						}
						else if (((HearEvent)e).playMode().startsWith("kick_in"))
						{
							if (forOurSide)
							{
								aktualPlayer.setPlayMode(1);
							}
							else
							{
								aktualPlayer.setPlayMode(2);
							}
						}
						else if (((HearEvent)e).playMode().startsWith("free_kick"))
						{
							if (forOurSide)
							{
								aktualPlayer.setPlayMode(1);
							}
							else
							{
								aktualPlayer.setPlayMode(2);
							}
						}
						else if (((HearEvent)e).playMode().startsWith("corner_kick"))
						{
							if (forOurSide)
							{
								aktualPlayer.setPlayMode(1);
							}
							else
							{
								aktualPlayer.setPlayMode(2);
							}
						}
						else if (((HearEvent)e).playMode().startsWith("goal_kick"))
						{
							if (forOurSide)
							{
								aktualPlayer.setPlayMode(1);
							}
							else
							{
								aktualPlayer.setPlayMode(2);
							}
						}
						else if (((HearEvent)e).playMode().startsWith("offside"))
						{
							aktualPlayer.setOffside(true);
							
							if (!forOurSide)
							{
								aktualPlayer.setPlayMode(1);
							}
							else
							{
								aktualPlayer.setPlayMode(0);
							}
						}
						else if (((HearEvent)e).playMode().startsWith("goal_"))
						{
							aktualPlayer.setPlayMode(0);						
						}
				
					} // else
				} // if playModeSet
			} // if isHearEvent()
		} // if (e != null) 
	
	} // updateWorld
	
	public double getDistanceFromCoordinates(double[] target)
	{
		double x,y;
		double distance;
		double [] position = myself.getTestPosition();
		x = Math.abs(position[0]-target[0]);
		y = Math.abs(position[1]-target[1]);
		distance = Math.sqrt(x*x+y*y);
		return distance;
	}



	// the method getDirectionFromCoordinates() returns the necessary angle
	// for turning towards a given coordinate
	
	
	public double getDirectionFromCoordinates(double[] target)
	{
	
	double x,y;
	double calAngle=0;
	double viewAngle;
	double distance;
	double angle=0;
	double [] position = myself.getTestPosition();
	
	 
	 x = Math.abs(position[0]-target[0]);
	 y = Math.abs(position[1]-target[1]);
//	 distance = Math.sqrt(x*x+y*y);
	 viewAngle = (myself.getViewDirection());
	 
	 		
	 		if ((position[0]-target[0]) >0) // target is on our left side
	 		{
				if ((position[1]-target[1]) >0) // target is over us
				{
				
	 				calAngle = ((Math.atan(y/x)*180)/java.lang.Math.PI);
					angle= 180 - calAngle - viewAngle;
//					if (aktualPlayer.isGoalie())
//					{
//						System.out.println(angle);
//					}
					angle = configureAngle(angle);
					return (-angle);
				}
				else // target is below us
				{
					
					calAngle = ((Math.atan(y/x)*180)/java.lang.Math.PI);
					angle = 180 + calAngle - viewAngle; 
//					if (aktualPlayer.isGoalie())
//					{
//						System.out.println(angle);
//					}
					angle = configureAngle(angle);
					return (-angle);
				}
				
	 		}
	 	
	 		else // (position[0]-target[0] <0 ) target is on our right side
	 		{
				if (position[1]-target[1] >0) // target is below us
				{
	 			
					calAngle = ((Math.atan(y/x)*180)/java.lang.Math.PI);
					angle = calAngle - viewAngle;
//					if (aktualPlayer.isGoalie())
//					{
//						System.out.println(angle);
//					}
					angle = configureAngle(angle);
					return (-angle);
				}
				else // target is above us
				{
				
					
					calAngle = ((Math.atan(y/x)*180)/java.lang.Math.PI);
					angle =  - calAngle - viewAngle;
//					if (aktualPlayer.isGoalie())
//					{
//						System.out.println(angle);
//					}
					angle = configureAngle(angle);
					return (-angle);
				}
				
	 		}
	
	}
	
	
	// function to convert angle in 360-style to (-180,180)-style
	public double configureAngle(double angle)
	{
		if (angle > 180)
		{
			angle = angle - 360;
		} 
		return angle; 
	} // configureAngle()
	
	// If it is not clear, this function prints the information about the player himself	
	public void printPlayer(boolean check)
	{
		if (check)
		{
			System.out.println("--------------------------------");
			System.out.println("| Spieler Nr    : " + aktualPlayer.ownNumber );
			System.out.println("| Zeit          : " + time  );
			System.out.println("| X-Postiton    : " + myself.getPosition()[0] );
			System.out.println("| Y-Postiton    : " + myself.getPosition()[1] );
			System.out.println("| Test X-Postiton: " + myself.getTestPosition()[0] );
			System.out.println("| Test Y-Postiton: " + myself.getTestPosition()[1] );
			System.out.println("| X-ActArea     : " + myActArea.field[0] );
			System.out.println("| Y-ActArea     : " + myActArea.field[1]);
			System.out.println("| ViewDirection : " + myself.getViewDirection() );
			System.out.println("| BodyDirection : " + myself.getBodyDirection() );
			System.out.println("| BallDirection : " + theBall.getBodyDirection() );
			System.out.println("| Ball time     : " + theBall.time()  );
			System.out.println("| X-BallPosition: " + theBall.getPosition()[0] );
			System.out.println("| Y-BallPosition: " + theBall.getPosition()[1] );
			System.out.println("| Old1 Ball time : " + theBall.time_1  );
			System.out.println("| Old1 X-BallPosition: " + theBall.Coordinates_1[0] );
			System.out.println("| Old1 Y-BallPosition: " + theBall.Coordinates_1[1] );
			System.out.println("| Old2 Ball time : " + theBall.time_2  );
			System.out.println("| Old2 X-BallPosition: " + theBall.Coordinates_2[0] );
			System.out.println("| Old2 Y-BallPosition: " + theBall.Coordinates_2[1] );
			System.out.println("| New Ball time : " + theBall.getNewTime()  );
			System.out.println("| New X-BallPosition: " + theBall.getNewPosition()[0] );
			System.out.println("| New Y-BallPosition: " + theBall.getNewPosition()[1] );
			System.out.println("--------------------------------");
		}
	}
	
// This function is called if the player has been activated by the
// graphicmodel

	public Vector getGraphicList(VisualEvent event )
	{
		// Type selection
		// 0 = Myself
		// 1 = Ball
		// 2 = Ball Ghost
		// 3 = Flag
		// 4 = OwnPlayer
		// 5 = Goal

		
		Vector VisualList = event.objectPerceptionList;
		Vector GraphicList = new Vector();
		int i = 0;
		ObjectPerception actual;
		GraphicObject go;
		
		//Myself Object
//		System.out.println("1");
		if (myself != null)
		{	
//			printPlayer(true);
			go = new GraphicObject(""+aktualPlayer.ownNumber,0,myself.getTestPosition(),myself.getViewDirection());
		
			GraphicList.addElement(go);
			if (myself.futurePos)
			{
				go = new GraphicObject("Player Ghost",6,myself.getNewPosition());
				GraphicList.addElement(go);
			} 
		}
		
		
		if (theGoal != null)
		{	
			double calculateGD = theGoal.direction();
			double calculateGD1 = getDirectionFromCoordinates(theGoal.getCoordinates());
			double calculateVD = myself.getViewDirection();
			double calculate;
			
//			System.out.println("Direction von Server " + calculateGD + " Direction von uns: " + calculateGD1);
				
				calculate = calculateVD - calculateGD1;
			
			
//			System.out.println("Direction Goal " + calculate);
			
			
			go = new GraphicObject("",5,myself.getPosition(),calculate,theGoal.getCoordinates());
		
			GraphicList.addElement(go);
		}
		
		
		
//			System.out.println("2");
		while (i < VisualList.size()) 
		{
			actual = (ObjectPerception)(VisualList.elementAt(i)); 
			// Flag Object
        	if (actual.name().startsWith("f")) 
            { 
                go = new GraphicObject(actual.name(),3,actual.getCoordinates());
//				System.out.println("x : "+ actual.getCoordinates()[0]);
				GraphicList.addElement(go); 
            } 
			// Ball Object
			else if (actual.name().startsWith("b")) 
			{ 
			    go = new GraphicObject("Ball",1,theBall.getPosition());
				GraphicList.addElement(go);
				if (theBall.futurePos)
				{
					go = new GraphicObject("Ball Ghost",2,theBall.getNewPosition());
					GraphicList.addElement(go);
				} 
			} 
			else if (actual.name().startsWith("p"))
			{
				
				int w; // 4, 7 oder 8
				StringTokenizer st   = new StringTokenizer(actual.name(), " ");
				
				int count = st.countTokens();
				st.nextToken();
				
				if (count == 1)
				{
					w=8;
				}
				else
				{
					String code = st.nextToken();
					if (code.equals("\""+aktualPlayer.teamName+"\""))
					{
						w=4;
					}
					else
					{
						w=7;
					}
				}
				
				go = new GraphicObject(actual.name(),w,event.getPlayerPosition(actual));
				GraphicList.addElement(go);
			}
			i++;
		}  
		
//		System.out.println("3");		
		return GraphicList;
	}
}
