import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;

/**
 * The class WorldModel is necessary for the visualization feature
 * Here, all important sight information is drawn into the WorldModel window
 *
 *
 *
 *  @author Henrik Sander
 *  @author Michael Helisch
 *  @author Manuel Link
 *  @author Max Urban
 *  @author Cornelius Siller 
 */
 
 public class WorldModel extends JFrame
{
	Image fieldpic;
	Image ball;
	Image ballghost;
	Image player;
	Image playerghost;
	Image flag;
	Image oppPlayer;
	Image unknownPlayer;
	
	
	CBildLeinwand m_bildanzeige;    //Leinwand zur Bildanzeige
	int m_bildheight, m_bildwidth;
	
	String titel = "RoboCup WorldModel 2002";
	Team team;



	// constructor
	
	public WorldModel(Team team)
	{
		super();
		
		this.team = team;
		ShowTitle(titel);
		
		
		fieldpic = null;	
		
		
		JPanel pane = new JPanel();	
		BorderLayout bo = new BorderLayout();
		pane.setLayout(bo);


		
		JMenuBar menueleiste = new JMenuBar();
		setJMenuBar(menueleiste);
		
		JMenu menu1 = new JMenu("File");
			
	
			JMenuItem item1 = new JMenuItem("Quit");
			item1.addActionListener(new ActionWatch());
			menu1.add(item1);
			menueleiste.add(menu1);
		
		JMenu menu2 = new JMenu("Show Players");
		
			JMenuItem item13 = new JMenuItem("Goalie");
			item13.addActionListener(new ActionWatch());
			menu2.add(item13);

			JMenuItem item3 = new JMenuItem("Defence 1");
			item3.addActionListener(new ActionWatch());
			menu2.add(item3);
		
			JMenuItem item4 = new JMenuItem("Defence 2");
			item4.addActionListener(new ActionWatch());
			menu2.add(item4);
			
			JMenuItem item5 = new JMenuItem("Defence 3");
			item5.addActionListener(new ActionWatch());
			menu2.add(item5);

			JMenuItem item6 = new JMenuItem("Midfield 1");
			item6.addActionListener(new ActionWatch());
			menu2.add(item6);

			JMenuItem item7 = new JMenuItem("Midfield 2");
			item7.addActionListener(new ActionWatch());
			menu2.add(item7);

			JMenuItem item8 = new JMenuItem("Midfield 3");
			item8.addActionListener(new ActionWatch());
			menu2.add(item8);

			JMenuItem item9 = new JMenuItem("Midfield 4");
			item9.addActionListener(new ActionWatch());
			menu2.add(item9);

			JMenuItem item10 = new JMenuItem("Offence 1");
			item10.addActionListener(new ActionWatch());
			menu2.add(item10);

			JMenuItem item11 = new JMenuItem("Offence 2");
			item11.addActionListener(new ActionWatch());
			menu2.add(item11);

			JMenuItem item12 = new JMenuItem("Offence 3");
			item12.addActionListener(new ActionWatch());
			menu2.add(item12);

		
			menueleiste.add(menu2);
		
		
		m_bildanzeige = new CBildLeinwand();
		pane.add("Center", m_bildanzeige);
			
		setContentPane(pane);
		
		
		//Frame bei einem WindowListener anmelden
		addWindowListener(new WindowWatch());
		LoadAllPictures();
		
	}	


	
			// Ereignisbehandlung fr das Fenster
		class WindowWatch extends WindowAdapter
		{
			public void windowClosing(WindowEvent e)
			{
				System.exit(0);
			}
		}


		// Ereignisbehandlung fr die Steuerelemente
		class ActionWatch implements ActionListener
		{
			public void actionPerformed(ActionEvent e)
			{
				String label;
				String memory;
				
				label = e.getActionCommand();
				
				if (label.equals("Quit"))
					System.exit(0);
				if (label.equals("Goalie"))
				{	
					memory = titel + " - "+label+" selected";
					ShowTitle(memory);
					System.out.println(label+" selected");
					select(0);
				}		
				if (label.equals("Defence 1"))
				{	
					memory = titel + " - "+label+" selected";
					ShowTitle(memory);
					System.out.println(label+" selected");
					select(1);
				}
				if (label.equals("Defence 2"))
				{	
					memory = titel + " - "+label+" selected";
					ShowTitle(memory);
					System.out.println(label+" selected");
					select(2);
				}
				if (label.equals("Defence 3"))
				{	
					memory = titel + " - "+label+" selected";
					ShowTitle(memory);
					System.out.println(label+" selected");
					select(3);
				}	
				if (label.equals("Midfield 1"))
				{	
					memory = titel + " - "+label+" selected";
					ShowTitle(memory);
					System.out.println(label+" selected");
					select(4);
				}
				if (label.equals("Midfield 2"))
				{	
					memory = titel + " - "+label+" selected";
					ShowTitle(memory);
					System.out.println(label+" selected");
					select(5);
				}
				if (label.equals("Midfield 3"))
				{	
					memory = titel + " - "+label+" selected";
					ShowTitle(memory);
					System.out.println(label+" selected");
					select(6);
				}
				if (label.equals("Midfield 4"))
				{	
					memory = titel + " - "+label+" selected";
					ShowTitle(memory);
					System.out.println(label+" selected");
					select(7);
				}
				if (label.equals("Offence 1"))
				{	
					memory = titel + " - "+label+" selected";
					ShowTitle(memory);
					System.out.println(label+" selected");
					select(8);
				}															
				if (label.equals("Offence 2"))
				{	
					memory = titel + " - "+label+" selected";
					ShowTitle(memory);
					System.out.println(label+" selected");
					select(9);
				}
				if (label.equals("Offence 3"))
				{	
					memory = titel + " - "+label+" selected";
					ShowTitle(memory);
					System.out.println(label+" selected");
					select(10);
				}					
				
			}
		}
		
				
		
		public void ShowTitle(String t)
		{
		
			setTitle(t);
		
		
		}
		
		
		class CBildLeinwand extends JPanel
		{
		// Panel neu zeichnen
			public void paintComponent(Graphics g)
			{
				super.paintComponents(g);
				// draw field
				g.drawImage(fieldpic,0,0,this);
				Vector Liste = team.GraphicList;
				GraphicObject bla;
				int i=0;
				int xco, yco;
				int cha, chb;
				double direct, a, b;
				if (Liste != null)
				{  
					while (i<Liste.size()) 
    		   		{ 
      			  		bla = (GraphicObject)(Liste.elementAt(i)); 
						
					

        				switch (bla.type)
						{
								// these assosiations 
								// Type selection
								// 0 = Myself
								// 1 = Ball
								// 2 = Ball Ghost
								// 3 = Flag
								// 4 = OwnPlayer
								// 5 = OwnPlayer Ghost
								// 6 = UnknownPlayer
								
							case 0: // draw line for viewdirection
									xco = xTranslate(bla.getPosition()[0]);
									yco = yTranslate(bla.getPosition()[1]);	
									direct = bla.getDirection();
									direct = - direct;
									a = 30 * Math.cos(direct*2*java.lang.Math.PI/360.0);
									b = 30 * Math.sin(direct*2*java.lang.Math.PI/360.0);
									cha = xco + (int)a;
									chb = yco + (int)b;	
									
									// draw player							
									g.drawImage(player,xTranslate(bla.getPosition()[0]) - 10,yTranslate(bla.getPosition()[1]) - 10,this);
									g.drawLine(xco,yco,cha,chb);
									break;		
		
							case 1: // draw ball
									g.drawImage(ball,xTranslate(bla.getPosition()[0]) - 10,yTranslate(bla.getPosition()[1]) - 10,this);
									break;
									
							case 2: // draw ghost ball
									g.drawImage(ballghost,xTranslate(bla.getPosition()[0]) - 10,yTranslate(bla.getPosition()[1]) - 10,this);
									break;
									
							case 3: // draw flags
									g.drawImage(flag,xTranslate(bla.getPosition()[0]),yTranslate(bla.getPosition()[1]) - 26,this);
									g.setColor(Color.blue);
									g.drawString(bla.getName(), xTranslate(bla.getPosition()[0]) - 10, yTranslate(bla.getPosition()[1]));
									g.setColor(Color.black);
									break;
									
							case 4: // draw known own players
									g.drawImage(player,xTranslate(bla.getPosition()[0]),yTranslate(bla.getPosition()[1]) - 26,this);
									g.drawString(bla.getName(), xTranslate(bla.getPosition()[0]) - 10, yTranslate(bla.getPosition()[1]));
									break;
									
							case 5: // draw line for goaldirection
									xco = xTranslate(bla.getPosition()[0]);
									yco = yTranslate(bla.getPosition()[1]);	
									direct = bla.getDirection();
									direct = - direct;
									a = 50 * Math.cos(direct*2*java.lang.Math.PI/360.0);
									b = 50 * Math.sin(direct*2*java.lang.Math.PI/360.0);
									cha = xco + (int)a;
									chb = yco + (int)b;	
									
									// draw player							
									g.drawImage(player,xTranslate(bla.getPosition()[0]) - 10,yTranslate(bla.getPosition()[1]) - 10,this);
									g.setColor(Color.red);
									g.drawLine(xco,yco,cha,chb);
									
									// draw goal
									g.setColor(Color.white);
									int gx = xTranslate(bla.getGoalPosition()[0]);
									int gy = yTranslate(bla.getGoalPosition()[1]);
									g.drawLine(gx, gy - 18, gx, gy + 18);
									g.setColor(Color.black);
									
									break;
									
							case 6: // draw ghost player
									g.drawImage(playerghost,xTranslate(bla.getPosition()[0])-10,yTranslate(bla.getPosition()[1]) - 10,this);		
							  		break;	
									
							case 7: // draw known opponent player
									g.drawImage(oppPlayer,xTranslate(bla.getPosition()[0]),yTranslate(bla.getPosition()[1]) - 26,this);
									g.setColor(Color.green);
									g.drawString(bla.getName(), xTranslate(bla.getPosition()[0]) - 10, yTranslate(bla.getPosition()[1]));
									g.setColor(Color.black);
									break;
									
							case 8: // draw unknown players
									g.drawImage(unknownPlayer,xTranslate(bla.getPosition()[0]),yTranslate(bla.getPosition()[1]) - 26,this);
									g.setColor(Color.red);
									g.drawString("unknown", xTranslate(bla.getPosition()[0]) - 15, yTranslate(bla.getPosition()[1]));
									g.setColor(Color.black);
									break;			
						}
						i++;
       				} 
					
				}
				g.dispose();
				team.newGraphic = true;
				
			}	
		
		}
		
		//set minimizing size
		public Dimension getMinimumSize()
		{
			return new Dimension(1024,740);
		}

		public Dimension getPreferredSize()
		{
			return getMinimumSize();
		}
		
				
		// int xTranslate(double x) returns the recalculating coordinate
		// to transform the dimension of the monitor-coordinates to the WorldModel
		// coordinates for the x-area
		
		public int xTranslate(double x)
		{
		
			double a = 800;
			int back;
		
			x = 7.6190476190476190476190476190476 * x;
			x = x + (a/2) + 112;
			
			back = (int) x;

			return back;
		
		
		}
		
		// int xTranslate(double x) returns the recalculating coordinate
		// to transform the dimension of the monitor-coordinates to the WorldModel
		// coordinates for the y-area
				
		public int yTranslate(double y)
		{
		
			double a= 519;
			int back;
			
			y= 7.6323529411764705882352941176471 * y;
			y = (y + (a/2)) + 90.5;
			
			
			back = (int) y;

			return back;
		
		
		}

	// select the active player for the worldmodel
	public void select(int player)
	{
		for (int i=0; i < 11; i++)
		{
			team.pa[i].deactivate();
		}
		team.pa[player].activate();
	}
		
	// LoadAllPictures() loads all necessary images, it
	// includes a loadcontrol function
	public void LoadAllPictures()
	{
			
		// Strings for the filename of each gif-image
		String path_player = "hut.gif";
		String path_playerghost = "hutghost.gif";
		String path_fieldpic = "field.gif";
		String path_ball = "ball.gif";
		String path_ballghost = "ballghost.gif";
		String path_flag = "flag.gif";
		String path_oppPlayer = "hut_opp.gif";
		String path_unknownPlayer = "hut_un.gif";
			
		Toolkit kit= Toolkit.getDefaultToolkit();
		MediaTracker loadcontrol = new MediaTracker(this);
		
		//Loading the field GIF
		fieldpic = kit.getImage(path_fieldpic);
		loadcontrol.addImage(fieldpic,0);
		
		try 
		{
			loadcontrol.waitForID(0);
		} 
		catch (InterruptedException e)
		{
			System.out.println("Feld nicht geladen!");
			return;
		}
		
			
		//Loading the ball GIF
		ball = kit.getImage(path_ball);
		loadcontrol.addImage(ball,1);
	
		try 
		{
			loadcontrol.waitForID(1);
		} 
		catch (InterruptedException e)
		{
			System.out.println("Ball nicht geladen!");
			return;
		}
		
		//Loading the ghost ball GIF
		ballghost = kit.getImage(path_ballghost);
		loadcontrol.addImage(ball,2);
	
		try 
		{
			loadcontrol.waitForID(2);
		} 
		catch (InterruptedException e)
		{
			System.out.println("BallGhost nicht geladen!");
			return;
		}
		
		//Loading the flag GIF
		flag = kit.getImage(path_flag);
		loadcontrol.addImage(flag,3);
		
		try 
		{
			loadcontrol.waitForID(3);
		} 
		catch (InterruptedException e)
		{
			System.out.println("Flagge nicht geladen!");
			return;
		}
		
		
		//Loading the player GIF
		player = kit.getImage(path_player);
		loadcontrol.addImage(player,4);
	
		try 
		{
			loadcontrol.waitForID(4);
		} 
		catch (InterruptedException e)
		{
			System.out.println("Player nicht geladen!");
			return;
		}
		
		//Loading the ghost player GIF
		playerghost = kit.getImage(path_playerghost);
		loadcontrol.addImage(playerghost,5);
	
		try 
		{
			loadcontrol.waitForID(5);
		} 
		catch (InterruptedException e)
		{
			System.out.println("Playerghost nicht geladen!");
			return;
		}
		m_bildheight = fieldpic.getHeight(m_bildanzeige);
		m_bildwidth = fieldpic.getWidth(m_bildanzeige);
		
		//Loading the opponent player GIF
		oppPlayer = kit.getImage(path_oppPlayer);
		loadcontrol.addImage(oppPlayer,6);
	
		try 
		{
			loadcontrol.waitForID(6);
		} 
		catch (InterruptedException e)
		{
			System.out.println("oppPlayer nicht geladen!");
			return;
		}
		
		//Loading the unknown player GIF
		unknownPlayer = kit.getImage(path_unknownPlayer);
		loadcontrol.addImage(player,8);
	
		try 
		{
			loadcontrol.waitForID(8);
		} 
		catch (InterruptedException e)
		{
			System.out.println("unknownPlayer nicht geladen!");
			return;
		}
		
	}	
		
}
	